# RFC-135: Setting default values for issue types on context

**URL:** <https://community.developer.atlassian.com/t/rfc-135-setting-default-values-for-issue-types-on-context/100893>\
**Category:** Request for Comments (RFC)\
**Tags:** jira-admin, jira-cloud-rest-api, jira-cloud, rest-api\
**Created:** [May 25, 2026, 2:11am UTC](https://community.developer.atlassian.com/t/rfc-135-setting-default-values-for-issue-types-on-context/100893 "2026-05-25T02:11:54Z")\
**Posts on this page:** 5\
**Page:** 1

<div class="post-metadata">

**Author:** ![JamesPetty](https://avatars.discourse-cdn.com/v4/letter/j/dec6dc/32.png) [@JamesPetty](https://community.developer.atlassian.com/u/JamesPetty)\
**Post date:** [May 25, 2026, 2:11am UTC](https://community.developer.atlassian.com/t/rfc-135-setting-default-values-for-issue-types-on-context/100893/1 "2026-05-25T02:11:54Z")

</div>

> **Update August:** We’ve announced an [early access program for multi contexts per space](https://community.atlassian.com/forums/Jira-Cloud-Admins-articles/Multiple-field-contexts-per-space-is-coming-to-Jira-join-the/ba-p/3277838#M3106). Please see the announcement blog for registration details and an updated rollout schedule.

As per the announcement: [support for multiple contexts per project is coming soon](https://community.developer.atlassian.com/t/multiple-contexts-per-project-is-coming-soon/99432), we’re adding the ability to set different default values for each issue type in a field context.

## Existing Default Values APIs

### Until March 2026

#### 1. Deprecated: Get Default Value

Requests to [Get custom field contexts default values](https://developer.atlassian.com/cloud/jira/platform/rest/v3/api-group-issue-custom-field-contexts/#api-rest-api-3-field-fieldid-context-defaultvalue-get) will continue to return the default value for contexts that only have a single default value. Contexts which have been configured to support more than one default value will not be returned.

#### 2. Deprecated: Set Default Value

Requests to [Set custom field contexts default values](https://developer.atlassian.com/cloud/jira/platform/rest/v3/api-group-issue-custom-field-contexts/#api-rest-api-3-field-fieldid-context-defaultvalue-put) will continue to populate the default value for all issue types associated with the context. If a context has different default values for particular issue types the API will override them all to use the new default value.

### After March 2026

The deprecated APIs will be removed.

## New Default Values APIs

### 1. Get Default Values

`GET /rest/api/3/field/{fieldId}/context/defaultValues`

Returns a paginated list of contexts with their default values.

The default value objects shape remains field type dependant and will follow the same structure as the [existing default values API](https://developer.atlassian.com/cloud/jira/platform/rest/v3/api-group-issue-custom-field-contexts/#api-rest-api-3-field-fieldid-context-defaultvalue-get).

**Query parameters:**

- `contextId` — repeatable; defaults to all contexts on the field the consumer can see.

- `issueTypeId` — repeatable; restricts returned issue types to the listed issue types only. Does not affect the any issue types default value.

- `startAt` — pagination offset, default 0.

- `maxResults` — page size, default 50, maximum 100.

**Example request**

`GET /rest/api/3/field/customfield_10010/context/defaultValues?contextId=12345`

**Example response** (200 OK)

```json
{
  "startAt": 0,
  "maxResults": 50,
  "total": 1,
  "values": [
    {
      "contextId": 12345,
      "defaultValues": [
        {
          "isAnyIssueType": true,
          "value": { ... }
        },
        {
          "issueTypeId": 10001,
          "value": { ... }
        },
        {
          "issueTypeId": 10002,
          "value": { ... }
        }
      ]
    }
  ]
}

```

### 2. Set Default Values

`PUT /rest/api/3/field/{fieldId}/context/defaultValues`

Allows updating default values for particular issue types in a context.

The default value can be removed by providing null.

If the issue type isn’t available on the requested context an exception will be returned. The issue type can be added to the context via [Add issue types to context](https://developer.atlassian.com/cloud/jira/platform/rest/v3/api-group-issue-custom-field-contexts/#api-rest-api-3-field-fieldid-context-contextid-issuetype-put).

**Example request**

`PUT /rest/api/3/field/customfield_10010/context/defaultValues`

```json
{
  "defaultValues": [
    {
      "contextId": 12345,
      "isAnyIssueType": true,
      "value": { ... }
    },
    {
      "contextId": 12345,
      "issueTypeId": 10001,
      "value": { ... }
    },
    {
      "contextId": 12345,
      "issueTypeId": 10002,
      "value": null
    }
  ]
}

```

## Other affected APIs

### Add issue types to context

New issue types added to a context via [Add issue types to context](https://developer.atlassian.com/cloud/jira/platform/rest/v3/api-group-issue-custom-field-contexts/#api-rest-api-3-field-fieldid-context-contextid-issuetype-put) inherit the default value from existing issue types. This will change once contexts support default values per issue type.

When adding an issue type to a context with default values, a new defaultValue parameter lets consumers control whether to copy default values from existing issue types. If omitted, the default value from the first issue type mapping in the context is copied.

Currently, adding issue types to a context configured as isAnyIssueType changes the context to map only to explicit issue types. We will now support a context being isAnyIssueType while also having explicit issue types. This allows an any issue type context to have specific default values for other issue types.

**Request body**

- `defaultValue` — object, optional; Object shape is field type dependant. When a default value is provided the new issue types being added will be set with the requested default. If the optional parameter isn’t provided the default value will be set to the same value of the contexts first issue type mapping.

- `isAnyIssueType` — boolean, optional; When true the isAnyIssueType mapping is added to the context, or kept if already present. When false or not provided the isAnyIssueType mapping is removed and replaced with the explicit issue types.

**Example request**

`PUT /rest/api/3/field/{fieldId}/context/{contextId}/issuetype`

```json
{
  "issueTypeIds": [
    "10001",
    "10005",
    "10006"
  ],
  "isAnyIssueType": true,
  "defaultValue": {
    "optionId": 10001,
    "type": "option.single"
  }
}

```

### Remove issue types from context

The current behaviour of the [remove issue types from context](https://developer.atlassian.com/cloud/jira/platform/rest/v3/api-group-issue-custom-field-contexts/#api-rest-api-3-field-fieldid-context-contextid-issuetype-remove-post) API is that removing all explicitly associated issue types from a context creates an any issue types mapping. This behaviour remains, but to ensure predictability, the new any issue types mapping will copy the default value from the oldest issue type mapping in the context.

---

<div class="post-metadata">

**Author:** ![BenRomberg](https://sea1.discourse-cdn.com/atlassiandeveloper/user_avatar/community.developer.atlassian.com/benromberg/32/51777_2.png) [@BenRomberg](https://community.developer.atlassian.com/u/BenRomberg)\
**Post date:** [May 26, 2026, 11:54am UTC](https://community.developer.atlassian.com/t/rfc-135-setting-default-values-for-issue-types-on-context/100893/2 "2026-05-26T11:54:37Z")

</div>

@JamesPetty Thanks for the RFC!

> [@JamesPetty](#):
>
> New Default Values APIs

When are those going to be available?

---

<div class="post-metadata">

**Author:** ![JamesPetty](https://avatars.discourse-cdn.com/v4/letter/j/dec6dc/32.png) [@JamesPetty](https://community.developer.atlassian.com/u/JamesPetty)\
**Post date:** [May 29, 2026, 1:34am UTC](https://community.developer.atlassian.com/t/rfc-135-setting-default-values-for-issue-types-on-context/100893/3 "2026-05-29T01:34:59Z")

</div>

Hey @BenRomberg we’ll be releasing the new APIs in July at the latest, but aiming to have them out by late June.

---

<div class="post-metadata">

**Author:** ![BenRomberg](https://sea1.discourse-cdn.com/atlassiandeveloper/user_avatar/community.developer.atlassian.com/benromberg/32/51777_2.png) [@BenRomberg](https://community.developer.atlassian.com/u/BenRomberg)\
**Post date:** [June 2, 2026, 11:24am UTC](https://community.developer.atlassian.com/t/rfc-135-setting-default-values-for-issue-types-on-context/100893/4 "2026-06-02T11:24:49Z")

</div>

FYI I (and probably other partners as well) would appreciate if with any deprecation, replacement APIs would be available right away instead of halfway through the deprecation notice period. I know Atlassian tries to adhere to a 6 month notice period, but it’s not worth much if we cannot migrate to new APIs right away.

---

<div class="post-metadata">

**Author:** ![JamesPetty](https://avatars.discourse-cdn.com/v4/letter/j/dec6dc/32.png) [@JamesPetty](https://community.developer.atlassian.com/u/JamesPetty)\
**Post date:** [June 4, 2026, 5:00am UTC](https://community.developer.atlassian.com/t/rfc-135-setting-default-values-for-issue-types-on-context/100893/5 "2026-06-04T05:00:10Z")

</div>

Thanks @BenRomberg, completely understandable! We’ll be looking to extend the end of the depreciation period based on when the new REST APIs become available so partners have time to properly transition.
